signature LIST_ADAPTIVE =
sig
  datatype 'a u = NIL | CONS of ('a  * 'a u AdaptiveMeta.Box.t)
  type 'a t = 'a u AdaptiveMeta.Box.t   
  type 'a alist = 'a t

  val map : ('a -> 'b) -> 'a t -$> 'b t
  val partition : ('a -> bool) -> 'a t -$> 'a t * 'a t
  val merge: ('a * 'a -> bool) -> ('a t * 'a t) -$> 'a t 
  val msort: ('a * 'a -> bool) -> 'a t -$> 'a t 
  
  val generateRandomList : int -> int list
  val generateSortedList : int -> int list

  val testLengthLessThan: int * int list -> unit
  val testMap : (int -> int) -> int list -> unit
  val testFilter : (int -> bool) -> int list -> unit
  val testPartition: (int -> bool) -> int list -> unit
  val testReverse: int list -> unit
  val testReduce: (int*int -> int) -> int list -> unit
  val testMSort: (int*int->bool) -> int list -> unit


end
