structure MergeHullGenerator : GENERATOR where type t = GeometryTwoD.Point.t list =
struct
   structure Geom = GeometryTwoD
   structure Point = Geom.Point

   type t = Point.t list

   val max = 4194304
   val rmax = real max

   fun gen {size, seed} =
      let
         val state = Random.rand (134567,seed)
         val randInt = Random.randRange (0, max)
         val randReal = fn () => real (randInt state)
         val randPoint = fn () => Point.new (randReal (), randReal ()) (*(0.0,0.0)*)
         fun rl(n') =
            if n'=0 then nil
            else (randPoint ())::(rl (n'-1))
      in
         rl size
      end
end
