(* WARNING: this file is automatically generated *)
structure MSortEqNonAdaptive : 
   sig
      include APPLICATION 
      val msort : 'a Key.t -> ('a * 'a -> bool) -> 'a ListNonAdaptive.t -$> 'a ListNonAdaptive.t
   end =
struct

   structure List = ListEqNonAdaptive
   open NonAdaptive
   open List

   val lengthLessThan = List.lengthLessThan

   structure HashF = HashFamily(val M = 2)

   fun partition keyElem = afn l =>
      let 
         val hashFun = HashF.hashFun ()
         fun randFun x = hashFun (Word.toIntX ((#hash keyElem) x)) = 0
      in 
         List.partition keyElem randFun $ l
      end

   val merge = fn keyElem => fn lt => afn (a : 'a List.t, b : 'a List.t) =>
      let
         val eqElem = #eq keyElem
         val {putM, ...} = PutMemoTable.mkPutEq $ (keyElem, eqCell eqElem)
         mfun merge (a, b) =
            case (get $ a, get $ b) of
               (NIL,b) => b
             | (a,NIL) => a
             | (CONS(ha,ta),CONS(hb,tb)) => 
                  if lt (ha, hb)
                     then CONS (ha, putM $ (ha, merge $ (ta,b)))
                  else CONS (hb, putM $ (hb, merge $ (a,tb)))
      in
         putThEq (eqCell eqElem) $ (afn () => merge $ (a, b))
      end

   val msort = fn keyElem => fn lt => afn (l : 'a List.t) =>
      let
         val eqElem = #eq keyElem
         val {putM, ...} = PutMemoTable.mkPutEq $ (Key.int, eqCell eqElem)
         mfun msort (l,d) =
            if get $ (lengthLessThan 2 $ l)
               then l
            else let
                    val (even, odd) = partition keyElem $ l
                    val even_s = msort $ (even,2*d)
		    val odd_s = msort $ (odd,2*d+1)
		    val l_s = merge keyElem lt $ (even_s, odd_s)
                 in
                    putM $ (d, get $ l_s)
                 end
      in
         msort $ (l,1)
      end

   type it = int ListNonAdaptive.t
   type ot = int ListNonAdaptive.t

   val lt : int * int -> bool = 
      fn (i1,i2) => Int.< (i1, i2)

   fun run l = NonAdaptive.call (msort Key.int lt, l)
end
