structure QSortEqAdaptive : 
   sig
      include APPLICATION 
      val qsort : 'a Key.t -> ('a * 'a -> bool) -> 'a ListAdaptive.t -$> 'a ListAdaptive.t
   end =
struct

   structure List = ListEqAdaptive
   open Adaptive
   open List

   val qsort = fn keyElem => fn lt => afn l =>
      let
         val eqElem = #eq keyElem
         val putM = #putM (PutMemoTable.mkPutEq $ (Key.option keyElem, eqCell eqElem))
         val partition = List.mk_partition $ keyElem
         mfun qsort (l,r) =
            case get $ l of
               NIL => r
             | CONS (hd, tl) => 
                  let 
                     val (L,G) = partition (fn y => lt (y, hd)) $ tl
                  in 
                     qsort $ (L, putM $ (SOME hd, CONS (hd, qsort $ (G, r))))
                  end
      in
         qsort $ (l, putM $ (NONE, NIL))
      end

   type it = int ListAdaptive.t
   type ot = int ListAdaptive.t

   val lt : int * int -> bool = 
      fn (i1,i2) => Int.< (i1, i2)

   fun run l = Adaptive.call (qsort Key.int lt, l)
end
