(**********************************************************************
 ** auto-coerce.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The implementation of coercions between (implicit) 
 ** adaptive functions and (explicit) continuation-passing-style 
 ** functions; the coercions are implemented as compiler primitives,
 ** which are realized by the ACPSTransform pass in the XML IL
 ** (<mlton>/mlton/xml/acps-transform.fun).
 **********************************************************************)

structure AutoCoerce :> AUTO_COERCE =
struct
   type 'a cont = 'a -> unit 
   type ('a, 'b) xfn = ('b cont * exn cont * 'a) cont

   val afn_to_xfn : ('a -$> 'b) -> ('a, 'b) xfn =
      _prim "Adaptive_afnToCont" : ('a -$> 'b) -> ('a, 'b) xfn;
   val xfn_to_afn : ('a, 'b) xfn -> ('a -$> 'b) =
      _prim "Adaptive_contToAfn" : ('a, 'b) xfn -> ('a -$> 'b);
end
