(**********************************************************************
 ** circular-list.sig
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for doubly-linked, circular lists.
 **********************************************************************)

signature POLY_CIRCULAR_LIST =
sig
   structure Elt : 
      sig
         type 'a t
         val get: 'a t -> 'a
      end

   type 'a t

   val empty: unit -> 'a t
   val insert: 'a t * 'a -> 'a Elt.t
   val remove: 'a t * 'a Elt.t -> unit
   val foreach: 'a t * ('a -> unit) -> unit
   val isEmpty: 'a t -> bool
end
