(* WARNING: this file is automatically generated *)
(**********************************************************************
 ** adaptive_auto.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The implementation of the adaptive library
 **********************************************************************)

structure NonAdaptiveUnAuto : NONADAPTIVE_UNAUTO =
struct
   (* Meta *)
   open NonAdaptiveMeta

   (* UnAuto *)
   open UnAutoCoerce

   type 'a thunk = unit -> 'a

   type 'a box = 'a Box.t
   type 'a dest = 'a NonAdaptiveCPS.Dest.t

   local
      val alloc = NonAdaptiveCPS.alloc
      val allocK : ('a Eq.t, 'a dest) xfn =
         fn (k,_,eq) => alloc (eq,k)
      val write = NonAdaptiveCPS.write
      val writeK : ('a dest * 'a, 'a box) xfn =
         fn (k,_,(d,x)) => write (d, x, k)
      val read = NonAdaptiveCPS.read
      val readK : ('a box, 'a) xfn =
         fn (k,_,b) => read (b, k)
   in
   val get : 'a box -> 'a = 
      fn (b : 'a box) =>
      let
         val x : 'a = (xfn_to_fn readK)  b
      in
         x
      end
   type ('a,'ax) putX = 'ax -> 'a box
   type 'a putTh = ('a, 'a thunk) putX
   type 'a put = ('a, 'a) putX
   val putThEq : 'a Eq.t -> 'a putTh =
      fn eq => fn (th : unit -> 'a) =>
      let
         val d : 'a dest = (xfn_to_fn allocK)  eq
         val x : 'a = th  ()
         val b : 'a box = (xfn_to_fn writeK)  (d, x)
      in
         b
      end
   val putEq : 'a Eq.t -> 'a put =
      fn eq => fn x =>
      let
         val d : 'a dest = (xfn_to_fn allocK)  eq
         val b : 'a box = (xfn_to_fn writeK)  (d, x)
      in
         b
      end
   end
  fun putTh a = (putThEq Eq.default)  a
  fun put a = (putEq Eq.default)  a


  structure PutMemoTable =
      struct
         type ('key,'a,'ax) putMX = 'key * 'ax -> 'a box
         type ('key,'a) putMTh = ('key, 'a, 'a thunk) putMX
         type ('key,'a) putM = ('key, 'a, 'a) putMX
         type ('key, 'a) t = {putMTh: ('key, 'a) putMTh,
                              putM: ('key, 'a) putM, 
                              mkPutM: unit -> ('key,'a) putM}
         type 'a dest = 'a NonAdaptiveCPS.AllocWriteMemoTable.Dest.t

         structure T = NonAdaptiveCPS.AllocWriteMemoTable.Table
         structure Table =
            struct
               type ('key, 'a) t = ('key, 'a) T.t
               val make = T.make
            end

         structure AW = NonAdaptiveCPS.AllocWriteMemoTable
         val allocK : ('a dest cont * exn cont * 'a Eq.t) cont =
            fn (k,_,eq) =>
            AW.alloc (eq,k)
         val writeK : ('key,'a) Table.t * 'key -> 
                      ('a box cont * exn cont * ('a dest * 'a)) cont =
            fn (table,key) => fn (k,_,(d,x)) =>
            AW.write (table,key) (d,x,k)
         val allocWriteK : ('key,'a) Table.t * 'key -> 
                           ('a box cont * exn cont * ('a Eq.t * 'a)) cont =
            fn (table,key) => fn (k,_,(eq,x)) =>
            AW.allocWrite (table,key) (eq,x,k)
         (* XXX use same table for putM and mkPutM *)
         val ('key,'a) mkPut_ =
            fn (table, eq) =>
            let
               val mkPutM : unit -> ('key,'a) putM =
                  fn () =>
                  let 
                     val d = (xfn_to_fn allocK)  eq
                  in 
                     fn (key, x) =>
                     let 
                        val b : 'a box = (xfn_to_fn (writeK (table, key)))  (d, x)
                     in 
                        b
                     end
                  end
               val putMTh : ('key, 'a) putMTh =
                  fn (key: 'key, th: 'a thunk) =>
                  let 
                     val putM = mkPutM  ()
                     val x = th  ()
                     val b = putM  (key, x)
                  in 
                     b
                  end
               val putM : ('key, 'a) putM =
                  fn (key, x) =>
                  let 
                     val b = xfn_to_fn (allocWriteK (table, key))  (eq,x)
                  in 
                     b
                  end
            in 
               {putMTh = putMTh,                
                putM = putM,
                mkPutM = mkPutM}
            end
         val mkPutEq =
            fn (keyKey, eq) =>
            let 
               val table = Table.make keyKey
            in 
               mkPut_  (table, eq)
            end
         val mkPut = fn () => mkPutEq  (Key.default, Eq.default)
      end

   val memoContEq = NonAdaptiveUnAutoMemo.memoCont
   val memoFixEq = NonAdaptiveUnAutoMemo.memoFix1
   val mkMemoFixEq = NonAdaptiveUnAutoMemo.mkMemoFix1
   val memoEq = NonAdaptiveUnAutoMemo.memo
   val mkMemoEq = NonAdaptiveUnAutoMemo.mkMemo



   val memoCont = NonAdaptiveUnAutoMemo.memoContDflt
   val memoFix = NonAdaptiveUnAutoMemo.memoFix1Dflt
   val mkMemoFix = NonAdaptiveUnAutoMemo.mkMemoFix1Dflt
   val memo = NonAdaptiveUnAutoMemo.memoDflt
   val mkMemo = NonAdaptiveUnAutoMemo.mkMemoDflt

   exception InitialRun
   type ('a, 'b) call_fn = 'a -> 'b
   val call = fn (f : ('a, 'b) call_fn, arg : 'a) =>
      let
         val r = ref (Result.Exn InitialRun)
         fun finish res = r := res
         val k0 = fn (v : 'b) => finish (Result.Value v)
         val h0 = fn (e : exn) => finish (Result.Exn e)
         val () = (fn_to_xfn f) (k0, h0, arg)
      in
         r
      end
end
