signature ALIST_EQ_ADAPTIVE =
sig
   datatype u = datatype AListAdaptive.u
   datatype t = datatype AListAdaptive.t
   datatype alist = datatype AListAdaptive.alist

   type 'a key =  'a Key.t
   type 'a eq  = 'a Eq.t

   val eqCell : 'a Eq.t -> 'a u Eq.t
   val hash : 'a t Hash.t
   val hashCell : 'a Hash.t -> 'a u Hash.t
   val key : 'a t Key.t
   val keyCell : 'a Key.t -> 'a u Key.t
   val fromList : 'a eq -> 'a list -$> 'a t

   val lengthLessThan : int -> 'a t -$> bool AdaptiveMeta.Box.t

   val append : 'a key -> 'a t * 'a t -$> 'a t
   val rev : 'a key -> 'a t -$> 'a t

   val map : ('a key * 'b Eq.t) -> ('a -> 'b) -> 'a t -$> 'b t
   val map_a : ('a key * 'b Eq.t) -> ('a -$> 'b) -> 'a t -$> 'b t

   val filter : 'a key -> ('a -> bool) -> 'a t -$> 'a t
   val filter_a : 'a key -> ('a -$> bool) -> 'a t -$> 'a t

   val filter2 : 'a key -> ('a -> bool) * ('a -> bool) -> 'a t -$> 'a t * 'a t
   val filter2_a :  'a key -> ('a -$> bool) * ('a -$> bool) -> 'a t -$> 'a t * 'a t

   type 'a partition = ('a -> bool) -> 'a t -$> 'a t * 'a t
   val partition : 'a key -> 'a partition
   val mk_partition : 'a key -$> 'a partition

   type 'a partition_a = ('a -$> bool) -> 'a t -$> 'a t * 'a t
   val partition_a : 'a key -> 'a partition_a
   val mk_partition_a : 'a key -$> 'a partition_a

   type 'a mkSplit = unit -> 'a -> bool
   type 'a reduce = 'a mkSplit -> ('a * 'a -> 'a) -> 'a -> 'a t -$> 'a AdaptiveMeta.Box.t
   val reduce : 'a key -> 'a reduce
   type 'a combine = 'a mkSplit -> ('a * 'a -> 'a) -> 'a t -$> 'a AdaptiveMeta.Box.t
   val combine : 'a key -> 'a combine

   type 'a combine_a = 'a mkSplit -> ('a * 'a -$> 'a) -> 'a t -$> 'a AdaptiveMeta.Box.t
   val combine_a : 'a key -> 'a combine_a
end
