signature ALIST_META_ADAPTIVE =
sig

   datatype u = datatype AListAdaptive.u
   datatype t =  datatype AListAdaptive.t
   datatype alist = datatype AListAdaptive.alist

   val new : 'a u -> 'a t
   val newEq : 'a Eq.t * 'a u -> 'a t
   val change : 'a t * 'a u -> unit
   val deref : 'a t -> 'a u

   val insertAt : 'a t * 'a -> 'a t
   val deleteAt : 'a t -> unit
   val deleteFirstAt : 'a t * ('a -> bool) -> unit
   val drop : 'a t * int -> 'a t

   val length : 'a t -> int
   val fromList : 'a list -> 'a t
   val fromListWithLast : 'a list -> 'a t * 'a t
   val toList : 'a t -> 'a list
   val toString : ('a -> string) -> 'a t -> string
end
