(**********************************************************************
 ** MOTION_SIMULATOR
 **
 ** Umut Acar, Kanat Tangwongsan, Jorge Vittes
 **
 ** Kinetic event scheduler
 **********************************************************************)

signature MOTION_SIMULATOR =
sig
  type event
  type stats = int * int * int * real * real 
  val EPSILON : real 
  val DELTA : real 
  val EXTERNAL_EVENT_FLAG: bool ref
  val init: unit -> unit
  val restart: unit -> unit

  val getTime: unit -> real
  val setTime:  real -> unit
  val cutOffTime: unit -> real
  val cutOffTimeUpper: unit -> real
  val getnEvents: unit -> int
  val incNFlips: unit -> unit
  val insert: event -> unit
  val simulate: int ->  stats * bool
  val simulateWithFun: (unit -> bool) -> stats * bool
  val simulateK: (real -> bool) option -> int ->  stats * bool
  val simulateUntil: int->real -> stats * bool
  val jumpTime: real -> unit
  val jumpNEvents: int -> unit
  val testSimulate: (real -> bool) -> stats * bool
  val testSimulateCont: (real -> bool) -> stats * bool
  val testSimulateUntil: (real->bool) -> real -> stats * bool
  val isDone: unit -> bool
end




