functor BuildListListInOut(structure Elt : ELT
		          structure NAElt : ELT
			  val convertElt: Elt.t -> NAElt.t) =
struct
   structure ListInOut =
      BuildListInOut(structure Elt = Elt 
                     structure NAElt = NAElt 
	             val convertElt = convertElt)
   structure Adaptive = 
      struct 
         type t = Elt.t ListAdaptive.t * Elt.t ListAdaptive.t
         val toString = fn (l1,l2) =>
            concat ["(", 
                    ListInOut.Adaptive.toString l1,
                    ",",
                    ListInOut.Adaptive.toString l2,
                    ")"]                    
      end
   structure NonAdaptive = 
      struct
         type t = NAElt.t ListNonAdaptive.t * NAElt.t ListNonAdaptive.t
         val toString = fn (l1,l2) =>
            concat ["(", 
                    ListInOut.NonAdaptive.toString l1,
                    ",",
                    ListInOut.NonAdaptive.toString l2,
                    ")"]
      end
   structure Converter =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun convert ((l1,l2) : a_t) : na_t =
            (ListInOut.Converter.convert l1,
             ListInOut.Converter.convert l2)
      end
   structure Checker =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun check ((l1,l2) : a_t, (l1',l2') : na_t) =
            ListInOut.Checker.check (l1,l1')
            andalso ListInOut.Checker.check (l2,l2')
      end
end
