(**********************************************************************
 ** BuildListToListTest.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: 
 **********************************************************************)

functor BuildListToListTest 
   (structure Elt : ELT
    structure NAElt : ELT
    val convertElt : Elt.t -> NAElt.t
    structure Generator : GENERATOR
       where type t = Elt.t list
    structure AdaptiveAutoApp : APPLICATION
       where type it = Elt.t ListAdaptive.t
       where type ot = Elt.t ListAdaptive.t
    structure NonAdaptiveAutoApp : APPLICATION
       where type it = NAElt.t ListNonAdaptive.t
       where type ot = NAElt.t ListNonAdaptive.t
    structure NonAdaptiveUnAutoApp : APPLICATION
       where type it = NAElt.t ListNonAdaptive.t
       where type ot = NAElt.t ListNonAdaptive.t) =
struct
   structure ListOutType = 
      BuildListInOut
      (structure Elt = Elt
       structure NAElt = NAElt
       val convertElt = convertElt
      )

   structure TestApp =
      TestListInputApp
      (structure InElt = Elt
       structure InNAElt = NAElt
       val convertElt = convertElt
       structure Generator = Generator
       structure OutType = ListOutType
       structure AdaptiveAutoApp = AdaptiveAutoApp
       structure NonAdaptiveAutoApp = NonAdaptiveAutoApp
       structure NonAdaptiveUnAutoApp = NonAdaptiveUnAutoApp)

   open TestApp
end
