(**********************************************************************
 ** BuildOrdListToOneTest.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: 
 **********************************************************************)

functor BuildOrdListToOneTest 
   (structure InElt : ELT
    structure InNAElt : ELT
    val convertElt : InElt.t -> InNAElt.t
    structure Generator : GENERATOR
       where type t = InElt.t list
    structure OutElt : ELT
    structure AdaptiveAutoApp : APPLICATION
       where type it = InElt.t list
       where type ot = OutElt.t 
    structure NonAdaptiveAutoApp : APPLICATION
       where type it = InNAElt.t list
       where type ot = OutElt.t 
    structure NonAdaptiveUnAutoApp : APPLICATION
       where type it = InNAElt.t list
       where type ot = OutElt.t) =
struct
   structure OutType = OutType (structure Elt = OutElt)

   structure TestApp =
      TestOrdListInputApp
      (structure InElt = InElt
       structure InNAElt = InNAElt
       val convertElt = convertElt
       structure Generator = Generator
       structure OutType = OutType
       structure AdaptiveAutoApp = AdaptiveAutoApp
       structure NonAdaptiveAutoApp = NonAdaptiveAutoApp
       structure NonAdaptiveUnAutoApp = NonAdaptiveUnAutoApp)

   open TestApp
end
