functor ListInOutType(structure Elt : ELT) =
struct
   structure Adaptive = 
      struct 
         type t = Elt.t ListAdaptive.t
         val toString = ListMetaAdaptive.toString Elt.toString
      end
   structure NonAdaptive = 
      struct
         type t = Elt.t ListNonAdaptive.t
         val toString = ListMetaNonAdaptive.toString Elt.toString
      end
   structure Converter =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun convert (l : a_t) : na_t =
            case ListMetaAdaptive.deref l of
               ListAdaptive.NIL => ListMetaNonAdaptive.new (Elt.eq, ListNonAdaptive.NIL)
             | ListAdaptive.CONS (x,t) =>
                  ListMetaNonAdaptive.new (Elt.eq, ListNonAdaptive.CONS (x, convert t))
      end
   structure Checker =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun check (l : a_t, l' : na_t) =
            case (ListMetaAdaptive.deref l, ListMetaNonAdaptive.deref l') of
               (ListAdaptive.NIL, ListNonAdaptive.NIL) => true
             | (ListAdaptive.CONS (x,t), ListNonAdaptive.CONS (x',t')) =>
                  Elt.eq (x, x') andalso check (t, t')
             | _ => false
      end
end
