functor ListListInOutType(structure Elt : ELT) =
struct
   structure ListInOutType =
      ListInOutType(structure Elt = Elt)
   structure Adaptive = 
      struct 
         type t = Elt.t ListAdaptive.t * Elt.t ListAdaptive.t
         val toString = fn (l1,l2) =>
            concat ["(", 
                    ListInOutType.Adaptive.toString l1,
                    ",",
                    ListInOutType.Adaptive.toString l2,
                    ")"]                    
      end
   structure NonAdaptive = 
      struct
         type t = Elt.t ListNonAdaptive.t * Elt.t ListNonAdaptive.t
         val toString = fn (l1,l2) =>
            concat ["(", 
                    ListInOutType.NonAdaptive.toString l1,
                    ",",
                    ListInOutType.NonAdaptive.toString l2,
                    ")"]
      end
   structure Converter =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun convert ((l1,l2) : a_t) : na_t =
            (ListInOutType.Converter.convert l1,
             ListInOutType.Converter.convert l2)
      end
   structure Checker =
      struct
         type a_t = Adaptive.t
         type na_t = NonAdaptive.t
         fun check ((l1,l2) : a_t, (l1',l2') : na_t) =
            ListInOutType.Checker.check (l1,l1')
            andalso ListInOutType.Checker.check (l2,l2')
      end
end
