(**********************************************************************
 ** RealElt.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: Real elements.
 **********************************************************************)

structure RealEltEq : 
   sig
      include ELT
      val fromInt : int -> t
   end =
struct
   type t = real

   val EPSILON = 0.00000001

   val fromInt = fn i => real i
   fun eq (a,b) = if (Real.-(a,b) < EPSILON) then true
		  else false
   fun toString a = Real.toString a
end
