(**********************************************************************
 ** StringElt.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: String elements.
 **********************************************************************)

structure StringElt : 
   sig 
      include ELT 
      val fromInt : int -> t
      val fromString: string -> t
   end =
struct
   type t = string
 
   val fromInt = fn i => 
      let
         val s = Int.fmt StringCvt.BIN i
         val p =
            CharVector.tabulate (32 - String.size s, fn _ => #"0")
      in 
         p ^ s
      end

   val fromString  = fn s => s

   val eq = Eq.string
   fun toString a = a
end
