(**********************************************************************
 ** StringIntElt.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: String*Integer elements.
 **********************************************************************)

structure StringIntElt : 
   sig 
      include ELT 
      val fromInt : int -> t
   end =
struct
   type t = string * int

   val fromInt = fn i => 
      let
         val s = Int.fmt StringCvt.BIN i
         val p =
            CharVector.tabulate (32 - String.size s, fn _ => #"0")
      in 
         (p ^ s, i)
      end

   val eq = Eq.tuple2 (Eq.string, Eq.int)
   fun toString (s,_) = s
end
